import React, { useEffect, useRef, useState } from "react";
import { Button, IconButton, TextField, Tooltip } from "@mui/material";
import LocalPhoneIcon from '@mui/icons-material/LocalPhone';
import CallEndIcon from '@mui/icons-material/CallEnd';
import AssignmentIndIcon from '@mui/icons-material/AssignmentInd';
import { CopyToClipboard } from "react-copy-to-clipboard";
import Peer from "simple-peer";
import io from "socket.io-client";
import "./App.css";
import styles from './App.module.scss';

/**
 * socket.io connection from the server running on port 5000. 
 */
const socket = io.connect('http://localhost:5000');

function App() {

	const [ me, setMe ] = useState("");
	const [ stream, setStream ] = useState();
	const [ receivingCall, setReceivingCall ] = useState(false);
	const [ caller, setCaller ] = useState("");
	const [ callerSignal, setCallerSignal ] = useState();
	const [ callAccepted, setCallAccepted ] = useState(false);
	const [ idToCall, setIdToCall ] = useState("");
	const [ callEnded, setCallEnded] = useState(false);
	const [ name, setName ] = useState("");
	const myVideo = useRef();
	const userVideo = useRef();
	const connectionRef= useRef();

	// will be triggered when the application loads/opens. 
	useEffect(() => {

		/**
		 * WebRTC's getUserMedia implementation from https://webrtc.org/
		 * @param { object } constraints a javascript object containing the webstc .getUserMedia constraints. 
		 * @returns resolved MediaStream object. 
		 */
		const openMediaDevices = async (constraints) => {
			return await navigator.mediaDevices.getUserMedia(constraints);
		}
		
		/**
		 * A try-catch block implementation/function call of the defined openMediaDevices() function.
		 */
		try {
			openMediaDevices({'video':true,'audio':true}).then((stream) => {
				//console.log('Got MediaStream:', stream);
				setStream(stream);
				if (myVideo.current) {
        			myVideo.current.srcObject = stream;
				}
			});
		} catch(error) {
			throw new Error("Error: ", error);
		}

		/**
		 * socket.io implementation that will be triggered when the application is opened in the browser. 
		 * Will generate the application instance's id that wil be used to call each other. 
		 */
		socket.on("me", (id) => {
			setMe(id);
		});

		/**
		 * socket.io implementation to enable peer to peer calling between app instances. 
		 */
		socket.on("callUser", (data) => {
			setReceivingCall(true);
			setCaller(data.from);
			setName(data.name);
			setCallerSignal(data.signal);
		});

	}, []);

	/**
	 * Event listeners to trigger the call functionality.
	 * @param { string } id accepts the id generated by the socket.io implementation inside the useEffect(). 
	 */
	const callUser = (id) => {
		const peer = new Peer({
			initiator: true,
			trickle: false,
			stream: stream
		});

		peer.on("signal", (data) => {
			socket.emit("callUser", {
				userToCall: id,
				signalData: data,
				from: me,
				name: name
			});
		});

		peer.on("stream", (stream) => {
			userVideo.current.srcObject = stream
		});

		socket.on("callAccepted", (signal) => {
			setCallAccepted(true);
			peer.signal(signal);
		});

		connectionRef.current = peer;
	}

	/**
	 * Event listener for answering call functionality.
	 */
	const answerCall = () =>  {

		setCallAccepted(true);
		const peer = new Peer({
			initiator: false,
			trickle: false,
			stream: stream
		});

		peer.on("signal", (data) => {
			socket.emit("answerCall", { signal: data, to: caller });
		});

		peer.on("stream", (stream) => {
			userVideo.current.srcObject = stream;
		});

		peer.signal(callerSignal);
		connectionRef.current = peer;
	}

	/**
	 * Event listener for leaving the call functionality.
	 */

	const leaveCall = () => {
		setCallEnded(true)
		connectionRef.current.destroy()
	}

	return (
		<main className={styles.main_container}>
			<section className={styles.content_container}>
				
				<section className={styles.content1}>
					<div className={styles.video_container}>
						<div className={styles.video}>
							{stream &&  <video playsInline muted ref={myVideo} autoPlay className={styles.video_stream} />}
						</div>

						<div className={styles.video}>
							{callAccepted && !callEnded ? <video playsInline ref={userVideo} autoPlay className={styles.video_stream} />: null}
						</div>
					</div>

					<div className={styles.my_id}>
						<TextField
							id="filled-basic"
							label="Enter your name"
							variant="outlined"
							value={name}
							onChange={(e) => setName(e.target.value)}
							className={styles.input_fields}
							InputLabelProps={{className: styles.input_fields}}
						/>

						<CopyToClipboard text={me} className={styles.copy_id}>
							<Tooltip title="Copy your Call ID" placement="top">
								<IconButton variant="contained" color="primary">
									<AssignmentIndIcon fontSize="large" />
								</IconButton>
							</Tooltip>
						</CopyToClipboard>

						<TextField
							id="filled-basic"
							label="ID of the person to call"
							variant="outlined"
							value={idToCall}
							onChange={(e) => setIdToCall(e.target.value)}
							className={styles.input_fields}
						/>

						<div className={styles.call_button}>
							{callAccepted && !callEnded ? (
								<Tooltip title="End Call" placement="top">
									<IconButton variant="contained" color="secondary" onClick={leaveCall}>
										<CallEndIcon fontSize="large" />
									</IconButton>
								</Tooltip>
							) : (
								<Tooltip title="Start Call" placement="top">
									<IconButton color="primary" aria-label="call" onClick={() => callUser(idToCall)}>
										<LocalPhoneIcon fontSize="large" />
									</IconButton>
								</Tooltip>
							)}
						</div>
					</div>
				</section>

				<section className={styles.content2}>
					<div className={styles.answer_call}>
						{
						receivingCall && !callAccepted ? (
							<div className={styles.caller}>
							<h1 >{name} is calling...</h1>
							<Button variant="contained" color="primary" onClick={answerCall}>
								Answer
							</Button>
							</div>
						) : null
						}
					</div>
				</section>
			</section>
			
		</main>
	)
}

export default App